//AB/ Project Inventory Item View (autoprompt)
//AB/   Object prj is a View_Project
//AB/     Set ProjectName to "Inventory Item View (autoprompt)"
//AB/     Set ProjectFileName to "Auto_Prompt_Invt.vw"

// Project Object Structure
//   oInvtAutoPrompt is a dbView
//     Vendor_DD is a DataDictionary
//     Invt_DD is a DataDictionary
//     dbCont is a dbContainer3d
//       Invt_Item_Id is a dbForm
//       Invt_Description is a dbForm
//       VendorGroup is a dbGroup
//         Invt_Vendor_Id is a vAppdbForm
//         Vendor_Name is a dbForm
//         Invt_Vendor_Part_Id is a dbForm
//       UnitGroup is a dbGroup
//         Invt_Unit_Price is a dbForm
//         Invt_On_Hand is a dbForm

// Register all objects
Register_Object dbCont
Register_Object Invt_DD
Register_Object Invt_Description
Register_Object Invt_Item_Id
Register_Object Invt_On_Hand
Register_Object Invt_Unit_Price
Register_Object Invt_Vendor_Id
Register_Object Invt_Vendor_Part_Id
Register_Object oInvtAutoPrompt
Register_Object UnitGroup
Register_Object Vendor_DD
Register_Object Vendor_Name
Register_Object VendorGroup


//AB/   AppBuild VIEW

  //AB-IgnoreStart

  Use vAppdbForm.pkg

  Use VENDOR.DD
  Use INVT.DD
  
  //AB-IgnoreEnd

  DEFERRED_VIEW Activate_oInvtAutoPrompt FOR ;
  ;
  Object oInvtAutoPrompt is a dbView
    Set Label to "Inventory Item View (auto-prompt)"
    Set Size to 166 320
    Set Location to 5 8

    //AB-DDOStart

    Object Vendor_DD is a Vendor_DataDictionary

      //AB-StoreStart
      // In order for the auto-prompt logic to be executed during a save you need to
      // manually turn off the findreq field-option.
      Set Foreign_Field_Options  DD_KEYFIELD   To DD_Clear_Field_Options DD_FINDREQ
      
      
      //AB-StoreEnd

    End_Object    // Vendor_DD

    Object Invt_DD is a Invt_DataDictionary
      Set DDO_Server to (Vendor_DD(self))
    End_Object    // Invt_DD

    Set Main_DD to (Invt_DD(self))
    Set Server to (Invt_DD(self))

    //AB-DDOEnd

    Object dbCont is a dbContainer3d
      Set Size to 141 307
      Set Location to 5 4
      Object Invt_Item_Id is a dbForm
        Entry_Item Invt.Item_id
        Set Label to "Invt. Item Id:"
        Set Size to 13 60
        Set Location to 10 70
        Set Label_Col_Offset to 2
        Set Label_Justification_Mode to jMode_Right
      End_Object    // Invt_Item_Id

      Object Invt_Description is a dbForm
        Entry_Item Invt.Description
        Set Label to "Invt. Description:"
        Set Size to 13 210
        Set Location to 25 70
        Set Label_Col_Offset to 2
        Set Label_Justification_Mode to jMode_Right
      End_Object    // Invt_Description

      Object VendorGroup is a dbGroup
        Set Label to "Vendor"
        Set Size to 58 271
        Set Location to 41 9
        Object Invt_Vendor_Id is a vAppdbForm
          Entry_Item Vendor.Id
          Set Label to "Vendor ID:"
          Set Size to 13 42
          Set Location to 9 61
          Set Label_Col_Offset to 2
          Set Label_Justification_Mode to jMode_Right

          //AB-StoreStart
          Set vpsAuto_Prompt_Help To "Please select a valid Vendor ID before you try to save"
          
          Set Item_validate_msg    To GET_vFindReq_auto_prompt
          //AB-StoreEnd

        End_Object    // Invt_Vendor_Id

        Object Vendor_Name is a dbForm
          Entry_Item Vendor.Name
          Set Label to "Vendor Name:"
          Set Size to 13 180
          Set Location to 24 61
          Set Label_Col_Offset to 2
          Set Label_Justification_Mode to jMode_Right
        End_Object    // Vendor_Name

        Object Invt_Vendor_Part_Id is a dbForm
          Entry_Item Invt.Vendor_part_id
          Set Label to "Vendor Part Id:"
          Set Size to 13 90
          Set Location to 39 61
          Set Label_Col_Offset to 2
          Set Label_Justification_Mode to jMode_Right
        End_Object    // Invt_Vendor_Part_Id

      End_Object    // VendorGroup

      Object UnitGroup is a dbGroup
        Set Size to 28 271
        Set Location to 101 9
        Object Invt_Unit_Price is a dbForm
          Entry_Item Invt.Unit_price
          Set Label to "Unit Price:"
          Set Size to 13 48
          Set Location to 10 61
          Set Label_Col_Offset to 2
          Set Label_Justification_Mode to jMode_Right
        End_Object    // Invt_Unit_Price

        Object Invt_On_Hand is a dbForm
          Entry_Item Invt.On_hand
          Set Label to "On Hand:"
          Set Size to 13 36
          Set Location to 10 205
          Set Label_Col_Offset to 2
          Set Label_Justification_Mode to jMode_Right
        End_Object    // Invt_On_Hand

      End_Object    // UnitGroup

    End_Object    // dbCont

  CD_End_Object    // oInvtAutoPrompt

//AB/   End_Object    // prj