//AB/ Project Auto Prompt Order Entry
//AB/ Object prj is a View_Project
//AB/   Set ProjectName to "Auto Prompt Order Entry"
//AB/   Set ProjectFileName to "Auto_Prompt_Order.VW"

// Project Object Structure
//   Auto_Prompt_Order_Entry is a dbView
//     Vendor_DD is a DataDictionary
//     Invt_DD is a DataDictionary
//     Customer_DD is a DataDictionary
//     Salesp_DD is a DataDictionary
//     Orderhea_DD is a DataDictionary
//     Orderdtl_DD is a DataDictionary
//     dbContainer3d1 is a dbContainer3d
//       Orderhea_Order_Number is a vAppdbForm
//       Orderhea_Customer_Number is a vAppdbForm
//       Orderhea_Order_Date is a dbSpinForm
//       Customer_Name is a vAppdbForm
//       Customer_Address is a vAppdbForm
//       Customer_City is a vAppdbForm
//       Customer_State is a vAppdbForm
//       Customer_Zip is a vAppdbForm
//       Orderhea_Ordered_By is a vAppdbForm
//       Orderhea_Salesperson_Id is a vAppdbForm
//       Orderhea_Terms is a dbComboForm
//       Orderhea_Ship_Via is a dbComboForm
//     OrderDtl_Grid is a vAppdbGrid
//     Orderhea_Order_Total is a vAppdbForm
//     PrintBtn is a Button
//     Order_Report is a CrystalReport

// Register all objects
Register_Object Auto_Prompt_Order_Entry
Register_Object Customer_Address
Register_Object Customer_City
Register_Object Customer_DD
Register_Object Customer_Name
Register_Object Customer_State
Register_Object Customer_Zip
Register_Object dbContainer3d1
Register_Object Invt_DD
Register_Object Order_Report
Register_Object OrderDtl_Grid
Register_Object Orderdtl_DD
Register_Object Orderhea_Customer_Number
Register_Object Orderhea_DD
Register_Object Orderhea_Order_Date
Register_Object Orderhea_Order_Number
Register_Object Orderhea_Order_Total
Register_Object Orderhea_Ordered_By
Register_Object Orderhea_Salesperson_Id
Register_Object Orderhea_Ship_Via
Register_Object Orderhea_Terms
Register_Object PrintBtn
Register_Object Salesp_DD
Register_Object Vendor_DD


//AB/ AppBuild VIEW


//AB-StoreTopStart
Use CrystalReport.pkg
//AB-StoreTopEnd

//AB-IgnoreStart

Use vAppdbForm.pkg
Use vAppdbGrid.pkg

Use VENDOR.DD
Use INVT.DD
Use CUSTOMER.DD
Use SALESP.DD
Use ORDERHEA.DD
Use ORDERDTL.DD

//AB-IgnoreEnd

DEFERRED_VIEW Activate_Auto_Prompt_Order_Entry FOR ;
;
Object Auto_Prompt_Order_Entry is a dbView

  //AB-StoreTopStart
  set Help_id to OrderEntryViewHelpId
  //AB-StoreTopEnd

  Set Label to "Order Entry"
  Set Size to 188 387
  Set Location to 2 3

  //AB-DDOStart

  Object Vendor_DD is a Vendor_DataDictionary
  End_Object    // Vendor_DD

  Object Invt_DD is a Invt_DataDictionary
    Set DDO_Server to (Vendor_DD(self))
  End_Object    // Invt_DD

  Object Customer_DD is a Customer_DataDictionary
  End_Object    // Customer_DD

  Object Salesp_DD is a Salesp_DataDictionary
  End_Object    // Salesp_DD

  Object Orderhea_DD is a Orderhea_DataDictionary
    Set DDO_Server to (Customer_DD(self))
    Set DDO_Server to (Salesp_DD(self))
  End_Object    // Orderhea_DD

  Object Orderdtl_DD is a Orderdtl_DataDictionary
    Set DDO_Server to (Orderhea_DD(self))
    Set DDO_Server to (Invt_DD(self))
    Set Constrain_File to Orderhea.File_Number
  End_Object    // Orderdtl_DD

  Set Main_DD to (Orderhea_DD(self))
  Set Server to (Orderhea_DD(self))

  //AB-DDOEnd

  Object dbContainer3d1 is a dbContainer3d
    Set Size to 85 377
    Set Location to 2 3
    Object Orderhea_Order_Number is a vAppdbForm
      Entry_Item Orderhea.Order_number
      Set Label to "Order Number:"
      Set Size to 13 42
      Set Location to 4 63
      Set Label_Col_Offset to 2
      Set Label_Justification_Mode to jMode_Right

      //AB-StoreStart
      // We want to disable the print button if there is no
      // current record. The DD notifies all DEOs of any record
      // change. We can augment any DEO's refresh message to see
      // if a current record exists and set the enabled_state of
      // print button accordingly.
      Procedure refresh integer iMode
          Integer iRec
          Forward Send Refresh iMode
          // if record exists, enable the print button.
          Get Current_record of (Server(self)) to iRec
          Set Enabled_State of PrintBtn to (iRec>0)
      End_procedure
      //AB-StoreEnd

    End_Object    // Orderhea_Order_Number

    Object Orderhea_Customer_Number is a vAppdbForm
      Entry_Item Customer.Customer_number
      Set Label to "Customer Number:"
      Set Size to 13 42
      Set Location to 4 201
      Set Label_Col_Offset to 2
      Set Label_Justification_Mode to jMode_Right

      //AB-StoreStart
                                                                  
      // If order record exists, disallow entry in customer window.
      Procedure Refresh Integer mode
         Integer Srvr# Crnt
         Get Server to Srvr#                 // get the data_set
         Get Current_Record of Srvr# to Crnt // get record in data_set
         // Set displayonly to true if Crnt is non-zero
         set object_shadow_state to (crnt<>0)
         Forward Send Refresh mode          // do normal refrsh
         // don't leave us sitting on a displayonly window
         If (crnt and Focus(self)=self) Send Next
      End_Procedure
      
      //AB-StoreEnd

    End_Object    // Orderhea_Customer_Number

    Object Orderhea_Order_Date is a dbSpinForm
      Entry_Item Orderhea.Order_date
      Set Label to "Order Date:"
      Set Size to 13 67
      Set Location to 4 299
      Set Label_Col_Offset to 2
      Set Label_Justification_Mode to jMode_Right
    End_Object    // Orderhea_Order_Date

    Object Customer_Name is a vAppdbForm
      Entry_Item Customer.Name
      Set Label to "Customer Name:"
      Set Size to 13 180
      Set Location to 18 63
      Set Label_Col_Offset to 2
      Set Label_Justification_Mode to jMode_Right
      Set Prompt_Button_Mode to pb_PromptOff

      //AB-StoreStart
      // We want this to be a displayonly field
      Set Object_Shadow_State to True
      
      //AB-StoreEnd

    End_Object    // Customer_Name

    Object Customer_Address is a vAppdbForm
      Entry_Item Customer.Address
      Set Label to "Street Address:"
      Set Size to 13 180
      Set Location to 34 63
      Set Label_Col_Offset to 2
      Set Label_Justification_Mode to jMode_Right
    End_Object    // Customer_Address

    Object Customer_City is a vAppdbForm
      Entry_Item Customer.City
      Set Label to "City/State/Zip:"
      Set Size to 13 84
      Set Location to 49 63
      Set Label_Col_Offset to 2
      Set Label_Justification_Mode to jMode_Right
    End_Object    // Customer_City

    Object Customer_State is a vAppdbForm
      Entry_Item Customer.State
      Set Size to 13 20
      Set Location to 49 155
    End_Object    // Customer_State

    Object Customer_Zip is a vAppdbForm
      Entry_Item Customer.Zip
      Set Size to 13 60
      Set Location to 49 183
    End_Object    // Customer_Zip

    Object Orderhea_Ordered_By is a vAppdbForm
      Entry_Item Orderhea.Ordered_by
      Set Label to "Ordered By:"
      Set Size to 13 67
      Set Location to 34 299
      Set Label_Col_Offset to 2
      Set Label_Justification_Mode to jMode_Right
    End_Object    // Orderhea_Ordered_By

    Object Orderhea_Salesperson_Id is a vAppdbForm
      Entry_Item Salesp.Id
      Set Label to "Salesperson Id:"
      Set Size to 13 40
      Set Location to 49 299
      Set Label_Col_Offset to 2
      Set Label_Justification_Mode to jMode_Right
    End_Object    // Orderhea_Salesperson_Id

    Object Orderhea_Terms is a dbComboForm
      Entry_Item Orderhea.Terms
      Set Label to "Terms:"
      Set Size to 13 85
      Set Location to 64 63
      Set Label_Col_Offset to 2
      Set Label_Justification_Mode to jMode_Right

      //AB-StoreStart
      Set entry_state to False
      //AB-StoreEnd

    End_Object    // Orderhea_Terms

    Object Orderhea_Ship_Via is a dbComboForm
      Entry_Item Orderhea.Ship_via
      Set Label to "Ship Via:"
      Set Size to 13 103
      Set Location to 64 183
      Set Label_Col_Offset to 2
      Set Label_Justification_Mode to jMode_Right

      //AB-StoreStart
      Procedure Switch
         // the normal switch beahvior is to attempt to keep
         // keep looking for additional objects to switch to if. If
         // we can't switch to the dtl table, we want to stop! So just
         // do a simple activate.
         Send Activate to OrderDtl_Grid
      End_Procedure
      
      Set Entry_State to False
      //AB-StoreEnd

    End_Object    // Orderhea_Ship_Via

  End_Object    // dbContainer3d1

  Object OrderDtl_Grid is a vAppdbGrid
    Set Main_File to Orderdtl.File_Number
    Set Server to (Orderdtl_DD(self))
    Set Ordering to 1
    Set Size to 63 377
    Set Location to 90 3
    Set Wrap_State to TRUE

    Begin_Row
      Entry_Item Invt.Item_id
      Entry_Item Invt.Description
      Entry_Item Invt.Unit_price
      Entry_Item Orderdtl.Price
      Entry_Item Orderdtl.Qty_ordered
      Entry_Item Orderdtl.Extended_price
    End_Row

    Set Form_Width    item 0 to 51
    Set Header_Label  item 0 to "Item Id"
    
    Set Form_Width    item 1 to 128
    Set Header_Label  item 1 to "Description"
    
    Set Form_Width    item 2 to 46
    Set Header_Label  item 2 to "Unit Price"
    
    Set Form_Width    item 3 to 44
    Set Header_Label  item 3 to "Price"
    
    Set Form_Width    item 4 to 43
    Set Header_Label  item 4 to "Quantity"
    
    Set Form_Width    item 5 to 55
    Set Header_Label  item 5 to "Total"
    

    //AB-StoreStart
    //-------------------------------------------------------------------
    // Change:   Table entry checking.
    //           Set child_table_state to true which will
    //           cause table to save when exiting and
    //           attempt to save header when entering.
    //-------------------------------------------------------------------
    
    Set child_table_state        to TRUE     // Saves when exit object
    
    // Called when entering the table. Check with the header if it
    // has a valid saved record. If not, disallow entry.
    //
    Function Child_entering returns Integer
       Integer rval
       // Check with header to see if it is saved.
       Delegate Get Save_Header to rval
       function_return rval // if non-zero do not enter
    End_Procedure
    
    //-------------------------------------------------------------------
    // Change:   Assign insert-row key append a row
    //           Create new behavior to support append a row
    //           Optimize the table refresh
    //-------------------------------------------------------------------
    
    On_key kADD_MODE send append_a_row
    
    // Add new record to the end of the table.
    procedure Append_a_Row      // Q: how would a keyboard do this?
        Send End_Of_Data        // A: Go to end of table and
        Send Down               //    down 1 line to empty line
    End_Procedure
    
    // The way this table is set up, items can never be added out
    // of order. New items are always added to the end of the table.
    // By setting Auto_Regenerate_State to false we are telling the
    // table to never bother reordering after adding records. This is
    // a minor optimization.
    Set Auto_Regenerate_state to false // table is always in order.
    
    
    //AB-StoreEnd

  End_Object    // OrderDtl_Grid

  Object Orderhea_Order_Total is a vAppdbForm
    Entry_Item Orderhea.Order_total
    Set Label to "Order Total:"
    Set Size to 13 60
    Set Location to 154 310
    Set Label_Col_Offset to 3
    Set Label_Justification_Mode to jMode_Right
  End_Object    // Orderhea_Order_Total

  Object PrintBtn is a Button
    Set Label to "Print Order"
    Set Location to 155 3

    //AB-StoreStart
    Procedure OnClick
        delegate Send PrintCurrentOrder // defined in view object
    End_procedure
    
    //AB-StoreEnd

  End_Object    // PrintBtn


  //AB-StoreStart
  //-----------------------------------------------------------------------
  // Change:   Create custom confirmation messages for save and delete
  //           We must create the new functions and assign verify messages
  //           to them.
  //-----------------------------------------------------------------------
  
  Function Confirm_Delete_Order Returns Integer
      Integer rval
      Get confirm "Delete Entire Order?" to rval
      Function_Return rval
  End_Function
  
  // Only confirm on the saving of new records
  Function Confirm_Save_Order Returns Integer
      Integer NoSave Srvr Rec
      Get Server to Srvr
      Get Current_Record of Srvr to Rec
      If (Rec =0) ;
         Get Confirm "Save this NEW order header?" to NoSave
      Function_Return NoSave
  End_Function
  
  // Define alternate confirmation Messages
  Set Verify_Save_MSG       to GET_Confirm_save_order
  Set Verify_Delete_MSG     to GET_Confirm_delete_order
  
  //-------------------------------------------------------------------
  // Change: Table entry checking - attempt to save header record
  //         before entering a table (this is called by table. Return
  //         a non-zero if the save failed (i.e., don't enter table)
  //-------------------------------------------------------------------
  
  Function Save_header returns integer
     Integer Rec Changed Srvr
     Get Server to Srvr                // The Header DDO.
     Get Current_Record of Srvr to Rec // The current order rec#.
     Get Should_Save to Changed        // Are there any current changes?
  
     // If there is no record and no changes we have an error.
     If (Rec=0 AND Changed=0) Begin // no rec
        Error 300 'You must First Create & Save Main Order Header'
        Function_Return 1
     End
  
     // Attempt to Save the current Record
     // request_save_no_clear does a save without clearing.
     Send request_save_no_clear
  
     // The save succeeded if there are now no changes, and we
     // have a saved record. Should_save tells us if we've got changes.
     // We must check the data-sets current_record property to see if
     // we have a record. If it is 0, we had no save.
     Get Should_Save to Changed  // is a save still needed
     Get Current_record of Srvr to Rec // current record of the DD
     // if no record or changes still exist, return an error code of 1
     If (Rec=0 OR Changed) ;
        Function_return 1
  end_function
  
  // Create a Crystal Report to print the current order. Object's
  // access method is: Send PrintOrder iOrderNumber
  //
  Object Order_Report is a CrystalReport
  
      Property integer OrderNumber public 0
  
      Set Report_Name to "Order1.rpt"
  
      Procedure onInitializeReport
         String sOrder
         Get OrderNumber to sOrder
         // create a custom title for the report
         Set ReportTitle to ("Print Order number" * String(sOrder))
         // Set the selection formula to print the one order.
         Set SelectionFormula To ("{OrderHea.Order_Number} = " + sOrder)
      end_procedure
  
      // pass order to print
      Procedure PrintOrder integer iNum
          Set OrderNumber to iNum
          Send Run_report
      End_procedure
  
  End_Object
  
  // print the current order. This message will be sent
  // by the print button
  Procedure PrintCurrentOrder
      Integer hDD iNum
      Get Server to hDD // this will be the orderhea DD 
      If (Current_record(hDD)) Begin // only do this if record exists
          Get Field_Current_Value of hDD Field Orderhea.Order_Number to iNum
          Send PrintOrder to Order_report iNum
      End
  End_Procedure
  
  //AB-StoreEnd

CD_End_Object    // Auto_Prompt_Order_Entry


//AB-StoreStart
      
//AB-StoreEnd

//AB/ End_Object    // prj